
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion


// to change from XBOX to regular Window, I have no idea how to, must create a separete project (for now)!!
//
// Differences ...
//
//      1. ->Applicaiton
//              OutputType: Console vs. Window Application
//      2. ->Build
//              a. Conditional compilation symbos:
//                      XBOX; XBOX360 (for XBOX)
//                      -- (nothing for Windows)
//              b. Output path: 
//                      bin\Xbox 360\Debug.. (for XBOX)
//                      bin\x86\Debug ... (for Window) 
//


namespace SimplePoints
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;

        private BasicEffect basicEffect;
        private EffectPool effectPool;
        private Matrix worldMatrix, viewMatrix, projectionMatrix;


        // these are the size of the offscreen drawing surface
        // in general, no one wants to change these as there
        // are all kinds of UI calculations and positions based
        // on these dimensions.
        const int FixedDrawingWidth = 1280;
        const int FixedDrawingHeight = 720;

        Circle2D myCircle;

        public Game1()
        {

            int w, h;

#if XBOX360
            w = FixedDrawingWidth;
            h = FixedDrawingHeight;
#else

            w = FixedDrawingWidth;
            h = FixedDrawingHeight;
#endif

            graphics = new GraphicsDeviceManager(this);
            graphics.PreferredBackBufferWidth = w;
            graphics.PreferredBackBufferHeight = h;

            // Game should run as fast as possible.
            IsFixedTimeStep = false;
        }


        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            //  my object
            myCircle = new Circle2D(graphics.GraphicsDevice, new Vector3(5.0f, 3.0f, 0.0f), 1.0f, 24);

            // my device settings
            graphics.GraphicsDevice.RenderState.DepthBufferEnable = false;
            graphics.GraphicsDevice.RenderState.MultiSampleAntiAlias = true;
            
            // render "effect"
            effectPool = new EffectPool();
            basicEffect = new BasicEffect(graphics.GraphicsDevice, effectPool);

            // initialize the transformation pipeline to draw in 12.8x7.2 area
            worldMatrix = new Matrix();
            viewMatrix = new Matrix();
            projectionMatrix = new Matrix();

            worldMatrix = Matrix.Identity;
            viewMatrix = Matrix.CreateScale(1.0f / 12.8f, 1.0f / 7.2f, 1.0f);
            projectionMatrix = Matrix.Identity;

            basicEffect.World = worldMatrix;
            basicEffect.View = viewMatrix;
            basicEffect.Projection = projectionMatrix;
            basicEffect.LightingEnabled = false;

            base.Initialize();
        }


       
        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the default game to exit on Xbox 360 and Windows
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            Vector3 c = myCircle.getCenter();
            c.Y -= 0.04f;
            
            if (c.Y < -7.0f)
            {
                c.Y = 7.0f;
            }
            myCircle.setCenter(c);

            base.Update(gameTime);
        }


        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            base.Draw(gameTime);

            // for now, I think the basicEffect is meant to be associated with each Primitive object
            basicEffect.Begin();
            basicEffect.Techniques[0].Passes[0].Begin();
            basicEffect.CommitChanges();

            // do the drawing of each primitives ...
                    myCircle.Draw(graphics.GraphicsDevice);

            basicEffect.Techniques[0].Passes[0].End();
            basicEffect.End();

        }
    }
}